#INCLUDE "dcdialog.CH"
#INCLUDE "appevent.ch"
#INCLUDE "xbp.ch"
#include "common.ch"

FUNCTION Main()

LOCAL GetList := {}, oDlg, oMenuBar, oSubMenu, oHelpMenu, GetOptions, oSubMenu2

DCMENUBAR oMenuBar

DCSUBMENU oSubMenu PARENT oMenuBar PROMPT 'Test' ACTION {||Thread():new():start({||Test(oDlg,1)})}

DCSUBMENU oSubMenu2 PARENT oMenuBar PROMPT 'Test2' ACTION {||Thread():new():start({||Test(oDlg,2)})}

DCSUBMENU oSubMenu2 PARENT oMenuBar PROMPT 'Test3' ACTION {||Thread():new():start({||Test(oDlg,3)})}


@ 0,0 DCSAY ''

@ 21,0 DCSAY '' SIZE 100,1.2

DCGETOPTIONS AUTOWINDOWMENU

DCREAD GUI FIT TITLE 'Test' PARENT @oDlg SETAPPWINDOW OPTIONS GetOptions

RETURN nil

* -------------

#define d_lEditmode      aApp[1]
#define d_bModify        aApp[2]                        //   action when modify button pressed
#define d_bDelete        aApp[3]                        //   action when delete button pressed
#define d_bSave          aApp[4]                        //   action when save button pressed
#define d_bCancel        aApp[5]
#define d_bQuit          aApp[6]                        //   action when quit button pressed 
#define d_oFirstget      aApp[7]
#define d_cTest1         aApp[8]
#define d_cTest2         aApp[9]
#define d_oDialog        aApp[10]

STATIC FUNCTION Test( oDlg, nMode )

LOCAL GetList[0], oDialog, aApp[10], oToolBar, GetOptions, bBlock

LOCAL date1 := date(), date2 := date()+30, date3 := date()+60
LOCAL wotype1:= space(10), wotype2:= space(10), wotype3:= 'WOTYPE3   '
LOCAL wotype4:= 'WOTYPE4   ', wotype5:= 'WOTYPE5   ', wotype6:= space(10)
LOCAL nTPWidth := 60, nTPHeight := 18
LOCAL nRow, nCol, oTabpage1, oTabstatic1, oPagegroup1, oIdent1, oXbp, oXbp1
LOCAL l1 := .T., l2 := .T., l3 := .T., l4 := .T.

  IF nMode $ {2,3}
    DC_HiliteGetsBlock({|o, nMode, nbColor| LB_HiliteGets( o, nMode, nbColor )})
  endif 

  IF nMode = 3
    dc_groupboxfix(.T.)
  ELSE
    dc_groupboxfix(.F.)
  ENDIF

                                                                                // Local Work Variables

  d_lEditmode     := .F.
  
  d_bModify := {|a,b,o,x| _ModifyRec(Getlist,aApp)}                             // Modify current record               

  d_bSave := {|a,b,o| iif(_SaveChanges(aApp)='C',;                              // Save the modified data
                        NIL,                     ;
                       (d_lEditmode := .F.,      ;
                        DC_GetRefresh(GetList),  ;
                        SetAppFocus( d_oDialog)) ;
                        )}
 
  d_bCancel := {|| d_lEditmode := .F., ;                                        // cancel key
                   DC_GetRefresh(GetList),    ;
                   SetAppFocus(d_oDialog) }
                             
  d_bQuit := {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }                       // Quit key                             

  DCHOTKEY xbeK_ESC ;                                                           // defines ESC key for not in edit mode
    ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;                     // exit dialog
    WHEN {|| !d_lEditmode} 


  @ 0,0 DCTABPAGE oTabpage1 ;                                                   // Tab Page 1 - Browse Screen
          EVAL {|o| LB_VisualStyle(o) }                ;
          TABWIDTH 13                                  ;
          CAPTION 'Test'                               ;
          SIZE nTPWidth,nTPHeight                      ;
          STATICAREA oTabstatic1                       ;

  DCSETPARENT TO oTabstatic1                                                    // defines tab page 2 data

  @ .2,1.1 DCSAY 'Date #1' GET date1 PICTURE '@D' ;
             GETOBJECT d_oFirstget 

  nRow := 1.2

  @ nrow, 2 DCCHECK l1 PROMPT 'Transparent' COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT

  @ nrow, DCGUI_COL+5 DCCHECK l2 PROMPT 'Background' COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND

  @ nrow, DCGUI_COL+5 DCCHECK l3 PROMPT 'Transparent1'   ; //COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT WHEN {|| .F.}
          PRESENTATION {{ XBP_PP_FGCLR, 1 },{ XBP_PP_BGCLR, -255 }}          ;
          WHEN {|| .F.}

  @ nrow, DCGUI_COL+5 DCCHECK l4 PROMPT 'Background1'  COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND WHEN {|| .F.}


  @ 3.5,.4 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX OBJECT oPagegroup1 ;
             SIZE nTPWidth-1.9,nTPHeight-5.0 PARENT oTabstatic1 

  @ .1, .5 DCGROUP oIdent1 SIZE nTPWidth-2.6,nTPHeight-5.3 ;
             PARENT oPagegroup1 ;
             CAPTION ' Identification' 
  
  DCSETPARENT TO oIdent1

  nRow := 1  
  
  @ nRow++, .5 DCSAY 'Date #2' GET date2 PICTURE '@D'
  nRow++
                
  @ nRow++, .5 DCSAY 'Date #3' GET date3 PICTURE '@D'
  nRow++

  @ nRow++, .5 DCSAY 'Writeoff Type 1' GET woType1 ;
                  PICTURE '@K!' 
  nRow++

  @ nRow++, .5 DCSAY 'Writeoff Type 2' GET woType2 ;
                  PICTURE '@K!' 
  nRow++

  @ nRow++, .5 DCSAY 'Writeoff Type 3' GET woType3 ;
                  PICTURE '@K!' 
  nRow++

//  @ nRow++, .5 DCSAY 'Writeoff Type 4' GET woType4 ;
//                  PICTURE '@K!' 

  @ nrow, 2 DCCHECKBOX l1 PROMPT 'Transparent' COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT

  @ nrow, DCGUI_COL+5 DCCHECKBOX l2 PROMPT 'Background' COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND

  @ nrow, DCGUI_COL+5 DCCHECKBOX l3 PROMPT 'Transparent2' COLOR GRA_CLR_BLACK,XBPSYSCLR_TRANSPARENT WHEN {|| .F.}  PARENT oIdent1 //OWNER oIdent1 

  @ nrow, DCGUI_COL+5 DCCHECKBOX l4 PROMPT 'Background2'  WHEN {|| .F.} COLOR GRA_CLR_BLACK,GRA_CLR_BACKGROUND

  nRow++
        
  nRow := nTPHeight+.2
  nCol := 1
  
  DCSETPARENT TO
  
  @ nrow,ncol DCTOOLBAR oToolBar SIZE 50 BUTTONSIZE 7,1

  DCADDBUTTON PARENT oToolBar CAPTION '~Modify' ;                               // Modify key
    ACTION d_bModify                              ;                             //   defined for tabpage > 1 and not edit mode
    ACCELKEY {Asc('M'),Asc('m')} ;
    WHEN {|| !d_lEditmode } ;

  DCADDBUTTON PARENT oToolBar SIZE 1,1 TYPE XBPSTATIC_TYPE_TEXT                 // Spacer
  
  DCADDBUTTON PARENT oToolBar CAPTION 'Save' ;                                  // Save Key
    SIZE 7,1 ;                                                                  //   defined for tabpage > 1 and not edit mode
    ACCELKEY {xbeK_PGDN} ;
    ACTION d_bSave ;
    WHEN {|| d_lEditmode }

  DCADDBUTTON PARENT oToolBar CAPTION 'Cancel' ;                                // Cancel key
    SIZE 7,1 ;                                                                  //   defined for edit mode
    ACTION d_bCancel      ;
    ACCELKEY {xbeK_ESC } ;
    CARGO 'CANCEL' ;
    WHEN {|| d_lEditmode}
  
  DCADDBUTTON PARENT oToolBar SIZE 1,1 TYPE XBPSTATIC_TYPE_TEXT                 // Spacer
  
  DCADDBUTTON PARENT oToolBar CAPTION '~Quit' ;                                 // Quit key
    ACTION d_bQuit          ;                                                   //   defined for all tab pages:  Alt-Q        
    SIZE 7, 1  ;
    ACCELKEY {Asc('Q'),Asc('q')} ;                                              //   defined for not in edit mode                        
    WHEN {|| !d_lEditmode}
  DCADDBUTTON PARENT oToolBar SIZE 1,1 TYPE XBPSTATIC_TYPE_TEXT                 // Spacer
  
  DCADDBUTTON PARENT oToolBar CAPTION '~Inspect' ;                              // Inspect key
    ACTION {|| dc_arrayview(AppDeskTop())}       ;                              //   defined for all tab pages:  Alt-I
    SIZE 7, 1  ;
    ACCELKEY {Asc('I'),Asc('i')} ;                                              //   defined for not in edit mode                        
    WHEN {|| !d_lEditmode}

  DCGETOPTIONS ;
    SAYRIGHTBOTTOM ;
    SAYWIDTH 120 ;
    EDITPROTECT {|| !d_lEditmode} ;
    NOCONFIRM ;
    HIDE ;  
    COLORGETS { {GRA_CLR_BLACK, GRA_CLR_YELLOW},{GRA_CLR_BLACK,GRA_CLR_WHITE} } ;
    HILITEGETS GRA_CLR_BLUE ;    
    NOESCAPEKEY ;
    NOSUPERVISE   

  DCREAD GUI ;
    FIT ;
    TITLE 'Test #'+str(nMode)+' '+iif(nMode=3,'Using dc_groupboxfix()',iif(nMode==2,'Using invalidaterect()','Just trying to clear using background color')) ;
    OPTIONS GetOptions ;
    SETFOCUS @d_oDialog ;                                                   
    APPWINDOW oDlg:drawingArea  ;
    EVAL {|o| d_oDialog := o,   ;
              o: configure(),   ;
                                ;
              oXbp1 := XbpCheckBox():new( oTabstatic1, oTabstatic1, {250,310-45}, {96,20}, { { XBP_PP_BGCLR, -255 } } ), ;
              oXbp1:caption := "Checkbox1",       ;
              oXbp1:tabStop := .T.,              ;
              oXbp1:create(),                    ;
              oXbp1:selected := {|| NIL },       ;
              oXbp1:disable(),   ;
                                ;       
                                ;
              oXbp := XbpCheckBox():new( oIdent1, oIdent1, {250,150}, {96,20}, { { XBP_PP_BGCLR, -255 },{ XBP_PP_FGCLR, 1 } } ), ;
              oXbp:caption := "Checkbox2", ;
              oXbp:tabStop := .T., ;
              oXbp:create(), ;
              oXbp:selected := {|| NIL }, ;
              oXbp:disable(), ;
              o: show() }
  
RETURN Nil

*+
*+
*+      STATIC Function _ModifyRec(GetList,aApp)
*+
*+      Modify the current record
*+
*+
*+
STATIC FUNCTION _ModifyRec(aMainGetList,aApp)

    d_lEditmode:=.T.
    DC_GetRefresh(aMainGetList)
    SetAppFocus(d_oFirstget)

  RETURN nil

*+
*+
*+    STATIC Function _SaveChanges(aApp)
*+
*+      Saves changes to database after confirmation
*+
*+
*+
STATIC FUNCTION _SaveChanges(aApp)
  LOCAL cStatus := 'Y'
  LOCAL lOption, nOption := 1
  
  BEGIN SEQUENCE

    lOption := DC_Msgbox(,,{"Save Changes"},"Confirmation",,,.T.,@noption)

    DO CASE
      CASE nOption == 1 
//        Eval(d_bGather)
      OTHERWISE
        cStatus := 'N'
        BREAK
    ENDCASE
    
  END SEQUENCE
  
  RETURN cStatus

* -------------

PROC appsys
RETURN

*+
*+
*+    Function LB_VisualStyle(oXbp,lBrowse)
*+
*+
*+
FUNCTION LB_VisualStyle(oXbp,lBrowse)

  DEFAULT lBrowse TO .F.
  IF !lBrowse 
    oXbp:UseVisualStyle := LB_IsThemeActiveTabPage()
  ENDIF
  IF lBrowse
    oXbp:HScrollObject:UseVisualStyle := .T.
    oXbp:VScrollObject:UseVisualStyle := .T. 
  ENDIF

  RETURN NIL
  
GETSETFUNCTION LB_IsThemeActiveTabPage DEFAULT .T.

*+
*+
*+    Function LB_HiliteGets( o, nMode, nbColor )
*+
*+      // Modification of DC_HiliteGets to remove the hilite when used with themes
*+
*+
*+ 
FUNCTION LB_HiliteGets( o, nMode, nbColor )

LOCAL oPS, nCol, nRow, nWidth, nHeight, aAttr[ GRA_AL_COUNT]

  IF o:isderivedfrom('XBPCOMBOBOX')
    nWidth := o:XbpSle:currentsize()[1]
    IF o:type # XBPCOMBO_SIMPLE
      nHeight := o:sleSize()[2]
      nCol := o:currentpos()[1]
      nRow := o:currentpos()[2] + o:currentsize()[2] - nHeight
    ELSE
      nHeight := o:currentsize()[2]
      nCol := o:currentpos()[1]
      nRow := o:currentpos()[2]
    ENDIF
  ELSE
    nCol := o:currentpos()[1]
    nRow := o:currentpos()[2]
    nWidth := o:currentsize()[1]
    nHeight := o:currentsize()[2]
  ENDIF

  IF IsMethod(o:SetParent(),'LOCKPS')
    oPS := o:setParent():lockPS()
  ENDIF

  IF nMode = 1                                                                  // draw the highlight
    IF Valtype(nbColor) == 'B'
      nbColor := Eval(nbColor)
      IF nbColor == NIL
        nbColor := o:setParent():setColorBG()
      ENDIF
    ENDIF
    aAttr[ GRA_AL_COLOR ] := nbColor
    GraSetAttrLine( oPS, aAttr )
    GraBox( oPS, {nCol-1,nRow-1}, {nCol+nWidth,nRow+nHeight}, GRA_OUTLINE )
  ELSE                                                                          // remove the highlight
    IF version(3) > '345' .AND. IsThemeActive(.T.)
      o:setParent():invalidateRect({nCol-1,nRow-1,nCol+nWidth+1,nRow+nHeight+1},,XBP_INVREGION_LOCK)
      o:setParent():invalidateRect({nCol,nRow,nCol+nWidth,nRow+nHeight},,XBP_INVREGION_XOR+XBP_INVREGION_RELEASE)
    ELSE
      aAttr[ GRA_AL_COLOR ] := GRA_CLR_BACKGROUND
      GraSetAttrLine( oPS, aAttr )
      GraBox( oPS, {nCol-1,nRow-1}, {nCol+nWidth,nRow+nHeight}, GRA_OUTLINE )
    ENDIF
  ENDIF

  IF Valtype(oPS) = 'O'
    o:setParent():unlockPS(oPS)
  ENDIF

  RETURN nil
 